<?php

/**
 * co_ejecucion_contrato actions.
 *
 * @package    contratacion
 * @subpackage co_ejecucion_contrato
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
require_once 'HTMLPurifier.auto.php';
require 'HTMLPurifier.autoload.php';

class co_ejecucion_contratoActions extends sfQuery
{
    /*
    * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
    */
    protected $table_names = array(
        'CO_EJECUCION_CONTRATO','CO_CONTRATO_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_CONTRATO_V' =>
        array(
            'id_contrato' => 'CO_EJECUCION_CONTRATO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
       'CO_EJECUCION_CONTRATO' =>
       array(
            'id_ejecucion_contrato' => 'id_ejecucion_contrato',
            'id_contrato' => 'id_contrato',
            'num_factura' => 'num_factura',
            'fecha_factura' => 'fecha_factura',
            'valor' => 'valor',
            'obligaciones' => 'obligaciones',
            'observaciones' => 'observaciones',
            'no_pago' => 'no_pago',
            'fecha_pago' => 'fecha_pago',
            'amortizacion_anticipo' => 'amortizacion_anticipo'
        ),
        'CO_CONTRATO_V' =>
        array(
            'no_contrato' => 'no_contrato',
            'id_anhos' => 'id_anhos',
            'proceso' => 'proceso',
            'valor' => 'valor_contrato',
            'completo_contra' => 'completo_contra',
            'completo_supervisor' => 'completo_supervisor'
            )
           
        
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
       'CO_EJECUCION_CONTRATO' =>
        array(    
            'id_ejecucion_contrato,a' => array('!=' => array(-1)),
            'id_ejecucion_contrato,b' => array('=' => array('id_ejecucion_contrato')),
            'id_contrato,b' => array('=' => array('id_contrato')),
            'estado' => array('=' => array('estado')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_ejecucion_contrato'; //identificador de la tabla
    protected $id_names = array('id_ejecucion_contrato'); //llave primaria
    protected $field_names = array('id_contrato', 'num_factura','fecha_factura','valor','obligaciones','observaciones','no_pago','fecha_pago','amortizacion_anticipo'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_EJECUCION_CONTRATO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_ejecucion_contrato'; //identificador unico de la tabla
    
    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        
        
            
        
        if ($Action == "ADD") {
            
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
           
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        $config = HTMLPurifier_Config::createDefault();
            $purifier = new HTMLPurifier($config);
        
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
            $obligaciones = $request['obligaciones'];            
            $obligaciones_limpio = $purifier->purify($obligaciones);
            
            $request['obligaciones'] = $obligaciones_limpio;
            
            $observaciones = $request['observaciones'];            
            $observaciones_limpio = $purifier->purify($observaciones);
            
            $request['observaciones'] = $observaciones_limpio;
            
            
            
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
             $obligaciones = $request['obligaciones'];            
            $obligaciones_limpio = $purifier->purify($obligaciones);
            
            $request['obligaciones'] = $obligaciones_limpio;
            
            $observaciones = $request['observaciones'];            
            $observaciones_limpio = $purifier->purify($observaciones);
            
            $request['observaciones'] = $observaciones_limpio;
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    } 
}
